/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March, 1997                                                    */
/* File Name : gaussMF.cc                                                */
/*************************************************************************/
/*************************************************************************/

#include "gaussMF.h"
#include "XgaussMF.h"
#include "Function.h"
#include "../deffunc.h"
#include <math.h>
#include <iostream.h>

gaussMF::gaussMF(float _center, float _std)
{  center = _center;
   stdeviation = _std;
   cutOff = 1.0;
}// end of constructor

void gaussMF::setSpread(float _newValue) {  stdeviation = _newValue; }

void gaussMF::setCenter(float _newValue) {  center = _newValue; }

float gaussMF::getCenter() const {  return center; }

float gaussMF::getSpread() const {  return stdeviation; }

float gaussMF::getValue(float x)
{  float ret;
   ret = exp(-0.5*sqr((x-center)/stdeviation));
   return minimum(ret,cutOff); 
}// end of getValue()

Function* gaussMF::Xversion()
{  XgaussMF *ret = new XgaussMF(center,stdeviation);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of Xversion()

Function* gaussMF::getMyTwin()
{  gaussMF *ret = new gaussMF(center,stdeviation);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of getMyTwin()

ostream& operator<<(ostream& os, const gaussMF& RHS)
{  os << " Gaussian("<<RHS.center<<","<<RHS.stdeviation<<") with " <<RHS.cutOff;
   return os;
}// end of operator<<

void gaussMF::printOn(ostream& os) const 
{  os << " Gaussian(" << center << "," << stdeviation << ") with " << cutOff;
}// end of printOn()

